;
; v_ima.pro :
;   Black and White plot of a Full Disc METEOSAT image (OpenMTP format)
;
;   Input : 
;   METEOSAT image before METEOSAT 8
;
;   Output :
;   Postscript file : optional
;
; Juin 2003 - ICARE - A.Alias 
;
pro v_ima

head_asc=bytarr(1345)
titre=''
fname=''
date=''
slot=''
filename=''

; Afficher les fichiers pour selection
filename = DIALOG_PICKFILE()

openr, fp, filename, /get_lun
readu,fp,head_asc

fname=strcompress(string(head_asc(0:79)))
if (strmatch(fname,'*PVIS*',/FOLD_CASE) EQ 1)  then begin
 ; Header binaire pour VIS : 192999 bytes
 titre="VIS METEOSAT Image"
 head_bin=bytarr(192999)
 count=bytarr(5000,2500)
 record=bytarr(5032,5000)
 chan=0
endif else begin
 ; Header binaire pour IR et WV : 144515 bytes
 if (strmatch(fname,'*PW*',/FOLD_CASE) EQ 1)  then begin
  titre="WV METEOSAT Image"
 endif else begin
  titre="IR METEOSAT Image"
 endelse
 head_bin=bytarr(144515)
 count=bytarr(2500,2500)
 record=bytarr(2532,2500)
 chan=1
endelse

readu,fp,head_bin
readu,fp,record
close,fp
free_lun,fp

slot=strcompress(string(head_asc(385:404)))
date=strcompress(string(head_asc(405:429)))
if (chan eq 0) then begin 
 count=record(32:5031,*)
endif else begin
 count=record(32:2531,*)
endelse

;
;
;--------------------------
; display
;--------------------------
print,"Save image to PS file (0:no|1:yes)"
read,ips
titre=strjoin([titre," ",date," ",slot])

window,1,tit=titre,xsize=600,ysize=600
tvscl,reverse(congrid(count,600,600)),TOP=255
if ips eq 1 then begin
   set_plot, 'PS'
   device, file='v_ima.ps', BITS=8, /LANDSCAPE ,  $
	      XSIZE=18., YSIZE=18., XOFFSET=2.0, YOFFSET=28.0
   tvscl,reverse(congrid(count,600,600)),TOP=255
   xyouts,0.005,0.97,titre,color=254
   print,"Image saved in  'v_ima.ps' "
endif 

end
